=== debian/changelog ===
supercollider (1:3.7.0~repack-4+deb9u1) stretch; urgency=medium

  [ Andreas Beckmann ]
  * Non-maintainer upload.
  * Backport disabling support for XEmacs etc. from 1:3.10.0+repack-0.1.

  [ Georges Khaznadar ]
  * modified emacsen configuration files to fit the patterns found
    with ELPA. This prevents the installation with xemacs and emacs <= 23.
    Closes: #916858

 -- Andreas Beckmann <anbe@debian.org>  Sat, 09 Feb 2019 22:39:14 +0100

supercollider (1:3.7.0~repack-4) unstable; urgency=medium

  [ Dan Stowell ]
  * Add notes about forwarded patches

  [ Felipe Sateler ]
  * Use gbp-pq for patches
  * Add patch to fix build failure when gcc doesn't handle 128bit float types
  * Bump debhelper compat level to 10
  * Switch from CDBS to short-form dh
  * Enable hardening flags
  * Drop unused lintian overrides

 -- Felipe Sateler <fsateler@debian.org>  Wed, 16 Nov 2016 20:27:41 -0300

supercollider (1:3.7.0~repack-3) unstable; urgency=medium

  * Team upload.
  * Add patch to fix oscpack FTBFS. (Closes: #824581)
  * Add epoch to supercollider-common Breaks + Replaces. (Closes: #824757)

 -- James Cowgill <jcowgill@debian.org>  Tue, 24 May 2016 18:09:01 +0100

supercollider (1:3.7.0~repack-2) unstable; urgency=medium

  [ Fernando Seiti Furusato ]
  * debian/rules: disabled altivec/vsx for ppc64el since the package does not
    support the usage for now

  [ Dan Stowell ]
  * Update copyright file headers
  * Restrict (optional) supernova to its target archs (amd64, i386m ia64)
    (Closes: #824581)
  * Fix lintian warnings about license names

  [ Felipe Sateler ]
  * Make supercollider-common Breaks/Replaces supercollider-gedit
    (Closes: #824757)
  * Drop unused dependency on libqtwebkit-dev (Closes: #784531)

 -- Felipe Sateler <fsateler@debian.org>  Thu, 19 May 2016 22:33:58 -0400

supercollider (1:3.7.0~repack-1) unstable; urgency=medium

  [ Dan Stowell ]
  * Update upstream url references (github now not sourceforge)
  * New Upstream version
    - Closes: #822467
    - Update dependencies for new version
    - Remove mathjax dependency management, dropped upstream
    - Remove boost-lockfree from copyright, dropped upstream
    - Refresh patches, and drop outdated ones
    - Update copyright information
    - Add patch to fix FTBFS when using system boost
    - Update install rules for changed readme filenames
    - Add patch to fix FTBFS, add -fPIC flag to tlsf build
  * Ignore lintian error about (unused) portaudio config files

  [ IOhannes m zmölnig ]
  * Use https:// in Vcs-Browser stanza

  [ Hanno Zulla ]
  * Update upstream homepage URL, fix vcs-field-uses-insecure-uri

  [ Felipe Sateler ]
  * Ship mime info in -common package, not -gedit package
  * Bump Standards-Version to 3.9.8
    - Drop menu files in favor of the desktop entries

  [ Jonas Smedegaard ]
  * Remove myself as uploader.

 -- Felipe Sateler <fsateler@debian.org>  Mon, 09 May 2016 20:59:52 -0300
